from rayon.scales import (
    LinearScale, 
    LinearBinnedScale,
    LinearGradientScale,
    RayonScaleException,
)
import unittest

class t_LinearScale(unittest.TestCase):
    def test_attach_1(self):
        s = LinearScale()
        s.attach([1,2,3], None)
        self.assertEqual(1, s.get_input_min())
        self.assertEqual(3, s.get_input_max())
            
    def test_attach_checks_input_1(self):
        s = LinearScale()
        self.assertRaises(RayonScaleException,
                          lambda: s.attach(["1", "2", "3"], None))


class t_LinearGradientScale(unittest.TestCase):
    def test_attach_1(self):
        s = LinearGradientScale()
        s.attach([1,2,3], None)
        self.assertEqual(1, s.get_input_min())
        self.assertEqual(3, s.get_input_max())
            
    def test_attach_checks_input_1(self):
        s = LinearGradientScale()
        self.assertRaises(RayonScaleException,
                          lambda: s.attach(["1", "2", "3"], None))

    
class t_LinearBinnedScale(unittest.TestCase):
    def test_attach_1(self):
        s = LinearBinnedScale(1)
        s.attach([1,2,3], None)
        self.assertEqual(1, s.get_input_min())
        self.assertEqual(3, s.get_input_max())
            
    def test_attach_checks_input_1(self):
        s = LinearBinnedScale(1)
        self.assertRaises(RayonScaleException,
                          lambda: s.attach(["1", "2", "3"], None))

    
